Subject: AJAX widgets broken when called inside a loop
Description

As ViewHelpers are supposed to be stateless they were create once per
RenderingContext and reused whenever the RenderingContext fits.
Some ViewHelpers are not stateless, e.g. AJAX widgets.

AJAX widgets push their WidgetContext into an AjaxWidgetContextHolder
before they get rendered.

As soon as AJAX-WidgetViewHelpers were used multiple times within the
same RenderingContext (widgets in ForViewHelpers for example) differet
widgets share the same ViewHelper containing the same WidgetContext.
Because the WidgetContext contains all statefull information about a
widget, only the last rendered widget gets stored in the ContextHolder.
That makes equal AJAX widgets within a for-loop impossible because
each GUI representation interacts with only the last rendered PHP object.

Associated revisions
Revision e4507941 - 2011-11-08 12:11 - Stephan Schuler

[FEATURE] Widgets: Reset WidgetViewHelpers when being reused from ViewHelperNode

    -  Introduce an AbstractViewHelper::resetState method to handle any kind
  of statefull interaction, empty by default.

    -  Make ViewHelperNode call resetState when reusing a ViewHelper, and also
  call it when reusing it in a compiled template.

    -  AbstractWidgetViewHelper implements resetState for creating a new
  WidgetContext object.

As ViewHelpers are supposed to be stateless they were create once per
RenderingContext and reused whenever the RenderingContext fits.
Some ViewHelpers are not stateless, e.g. AJAX widgets.

AJAX widgets push their WidgetContext into an AjaxWidgetContextHolder
before they get rendered.

As soon as AJAX-WidgetViewHelpers were used multiple times within the
same RenderingContext (widgets in ForViewHelpers for example) differet
widgets share the same ViewHelper containing the same WidgetContext.
Because the WidgetContext contains all statefull information about a
widget, only the last rendered widget gets stored in the ContextHolder.
That makes equal AJAX widgets within a for-loop impossible because
each GUI representation interacts with only the last rendered PHP object.

A test case has been committed to Viewhelpertest with http://review.typo3.org/6594

Resolves: #31667
Release: 1.0, 1.1
Change-Id: I543fd9771b3c5f9d7b9693980f3b1c17dff28996

Revision 79e1d935 - 2011-11-12 20:58 - Stephan Schuler

[BUGFIX] Reset WidgetViewHelpers when being reused from ViewHelperNode

    -  Introduce an AbstractViewHelper::resetState method to handle any kind
  of stateful interaction, empty by default.

    -  Make ViewHelperNode call resetState when reusing a ViewHelper, and also
  call it when reusing it in a compiled template.

    -  AbstractWidgetViewHelper implements resetState for creating a new
  WidgetContext object.

As ViewHelpers are supposed to be stateless they were create once per
RenderingContext and reused whenever the RenderingContext fits.
Some ViewHelpers are not stateless, e.g. AJAX widgets.

AJAX widgets push their WidgetContext into an AjaxWidgetContextHolder
before they get rendered.

As soon as AJAX-WidgetViewHelpers were used multiple times within the
same RenderingContext (widgets in ForViewHelpers for example) different
widgets share the same ViewHelper containing the same WidgetContext.
Because the WidgetContext contains all stateful information about a
widget, only the last rendered widget gets stored in the ContextHolder.
That makes equal AJAX widgets within a for-loop impossible because
each GUI representation interacts with only the last rendered PHP object.

A test case has been committed to Viewhelpertest with http://review.typo3.org/6594

Change-Id: I7b0b1779079d4e48399d8db4981f2e6a24ebe536
Fixes: #31667
Release: 1.0, 1.1

History
#1 - 2011-11-08 11:41 - Sebastian Kurfuerst
- Status changed from New to Under Review

see https://review.typo3.org/#change,2602

#2 - 2011-11-08 12:05 - Mr. Hudson

Patch set 3 of change I543fd9771b3c5f9d7b9693980f3b1c17dff28996 has been pushed to the review server.
It is available at http://review.typo3.org/2602

#3 - 2011-11-08 12:07 - Sebastian Kurfuerst

Please use http://review.typo3.org/6594 for testing

#4 - 2011-11-08 12:08 - Mr. Hudson

Patch set 4 of change I543fd9771b3c5f9d7b9693980f3b1c17dff28996 has been pushed to the review server.
It is available at http://review.typo3.org/2602

#5 - 2011-11-08 12:11 - Mr. Hudson

Patch set 5 of change I543fd9771b3c5f9d7b9693980f3b1c17dff28996 has been pushed to the review server.
It is available at http://review.typo3.org/2602

#6 - 2011-11-08 12:36 - Stephan Schuler
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:e45079412d945aab812a48933ea5c3ff362e0b08.

#7 - 2011-11-12 20:56 - Karsten Dambekalns
- Category set to Widgets
- Assigned To set to Sebastian Kurfuerst
- Target version set to 1.0.1
